﻿var gameVars = ["events0", "prev", "stay", "neutral", "go", "extra", "temp0", "temp1", "temp2", gCssSize];
var gamePersists = [gUserChose, gUserSize];

var gameAchieves = ["e3embarrass", "e4sandy", "e4laura", "e4walk", "e5neutral", "e5stay", "e5go"];

var gameStartPage = "_begin";

var gameTitle = "Coming to Grips with Christine";
var gameDelim = "CtGwC";

var gameNumDebugCols = 3;
var gameDoDebug = 0;

var gameNumSaveRows = 3;
var gameNumSaveCols = 3;

var gameScreenWidths = [0, 1280, 1920];
var gameScreenHeights = [0, 900, 1080];

// in a fcn: SetEvent('events0', 'showNeeded');
// events0
var reserved = 0;
var noAudio = 1;
var e3morn = 2;
var e3confess = 3;
var e4bar = 4;
var e4book = 5;
var e4laura = 6;
var e4sandy = 7;

var numEvents0 = 8;

var typeNone = 0;
var typeStay = 1;
var typeNeutral = 2;
var typeGo = 3;

var e1Rela = 11;

var animHelper;
var eId;
var mouseFrames;
var audio;

function SetBanner() 
{
    var banner = document.getElementById("banner");

    var str = "<p id=\"toptext\">Support the making of our games by becoming a <a href=\"https://www.patreon.com/tora\" target=\"_blank\">patron</a>" +
        " or by <a href=\"http://sitepro.arvixe.com/data/s/u/supportmortzeart.com/out/1/\" target=\"_blank\">donating directly</a> to Tlaero and Mortze. Any amount is appreciated.</p>" +
        "<p><a href=\"https://www.patreon.com/tora\" target=\"_blank\"><img class=\"alignnone size-full wp-image-185\" src=\"files/images/ElsaPatreonIraybaner.jpg\" alt=\"ElsaPatreonIraybaner\" width=\"200\" height=\"100\" /></a></p>" +
        "<p id=\"toptext\">Or visit us on <a href=\"http://MortzeArt.com\">MortzeArt.com</a></p>";

    banner.innerHTML = str;
}

function ClearBanner() 
{
    var banner = document.getElementById("banner");
    banner.innerHTML = "";
}

function GameShowScore()
{
    var inStats = ReadVar(gInStats);

    if (inStats)
    {
        var numSetAchieves = CountSetAchieves();
        var numMaxAchieves = CountMaxAchieves();

        if (numSetAchieves < numMaxAchieves)
        {
            var stats = gtEarned + numSetAchieves + gtOutOf + numMaxAchieves + gtAchievements;

            OutputScoreString(stats);
        }
        else
        {
            var bonus = gtBonusText + "<button onclick=\"LoadPage('bonus0');\" >" + gtBonus + "</button> "; 

            OutputScoreString(bonus);
        }

        //OutputScoreString("");
    }
    else
    {
        //var menu = "<button onclick=\"GotoStatsPage('_menu');\" >" + gtMenu + "</button> ";
        //var save = " <button onclick=\"SaveState('0');\" >" + gtSave + "</button> ";
        //var restore = " <button onclick=\"RestoreState('0');\" >" + gtRestore + "</button> ";

        var menu = " <button class='ctrl' id='menu' onclick=\"GotoStatsPage('_menu');\" title=\""+ gtMenu + "\"></button> ";
        var save = " <button class='ctrl' id='save' onclick=\"SaveState('0');\" title=\"" + gtSave + "\"></button> ";
        var restore = " <button class='ctrl' id='restore' onclick=\"RestoreState('0');\" title=\"" + gtRestore + "\"></button> ";
        var audio = " <button class='ctrl' id='audio' onclick=\"ToggleAudio();\" title=\"" + gtAudio + "\"></button> ";

        var noAudio = CheckEvent("events0", "noAudio");
        if (noAudio)
        {
            audio = " <button class='ctrl' id='noaudio' onclick=\"ToggleAudio();\" title=\"" + gtAudio + "\"></button> ";
        }

        OutputScoreString(save + menu + restore + audio);
    }    
}

function ToggleAudio()
{
    var noAudio = CheckEvent("events0", "noAudio");

    if (noAudio)
    {
        ClearEvent("events0", "noAudio");
    }
    else
    {
        SetEvent("events0", "noAudio");
    }

    location.reload();
}


function GameDebugConfigureEvents()
{
    var str;

    str = ConfigureEvents(0);
    //str += ConfigureEvents(1);

    return str;
}

function ConfigureEvents(num)
{
    var eventStr = "events" + num;
    var index;
    var events = ReadVar(eventStr);
    var str = "<br/><br/>Modify " + eventStr + " 0x" + events.toString(16) + " | ";

    var max = window["numEvents" + num];

    for (index = 0; index < max; index++)
    {
        var val = ReadVarBit(eventStr, index);
        str += val + " <button onclick=\"SetVarBit('" + eventStr + "', " + index + ");\">S" + index + "</button> <button onclick=\"ClearVarBit('" + eventStr + "', " + index + ");\">C" + index + "</button> | ";
    }

    return str;
}

function PlaySound(fileName)
{
    var noAudio = CheckEvent("events0", "noAudio");

    if (!noAudio)
    {
        if (typeof (audio) != "undefined" && audio != null)
        {
            audio.pause();
        }
        
        audio = new Audio("files/audio/" + fileName);
        audio.play();
    }
}

function StopSound()
{
    audio.pause();
}

function Size()
{
    var size = ReadVar("cssSize");
    var str;
    switch (size)
    {
        default:
        case 0:
            str = gtSmall;
            break;

        case 1:
            str = gtMedium;
            break;

        case 2:
            str = gtLarge;
            break;
    }

    return str;
}


function ChoosePict(event)
{
    var isSet = CheckEvent("events0", event);
    if (isSet)
    {
        var str = document.getElementById(gImageId).src;
        str = str.replace(".jpg", "b.jpg");
        document.getElementById(gImageId).src = str;
    }
}


function ChoosePage(event, page1, page2)
{
    var isSet = CheckEvent("events0", event);

    if (typeof (page1) != "undefined" && typeof (page2) != "undefined")
    {
        if (isSet)
        {
            LoadPage(page1);
        }
        else
        {
            LoadPage(page2);
        }
    }
    else if (isSet)
    {
        var page = GetCurrentPageName();
        //page = page.substring(0, page.length - 1);
        page += "b";
        LoadPage(page);
    }
}

function ChooseText(event, text1, text2)
{
    var isSet = CheckEvent("events0", event);
    if (isSet)
    {
        return text1;
    }
    else
    {
        return text2;
    }
}

function C(type)
{
    SetVar("prev", type);

    switch (type)
    {
        case typeStay:
            AddToVar("stay", 1);
            break;

        case typeNeutral:
            AddToVar("neutral", 1);
            break;

        case typeGo:
            AddToVar("go", 1);
            break;
    }
}

function Prev(stay, neutral, go)
{
    var prev = ReadVar("prev");

    switch (prev)
    {
        case typeStay:
            return stay;
            break;

        default:
        case typeNeutral:
            return neutral;
            break;

        case typeGo:
            return go;
            break;
    }
}

function Rela(stay, neutral, go)
{
    var rela = CalcRela();

    switch (rela)
    {
        case typeStay:
            return stay;
            break;
     
        case typeNeutral:
        default:
            return neutral;
            break;

        case typeGo:
            return go;
            break;
    }
}

function GotoRela(stay, neutral, go)
{
    var rela = CalcRela();

    switch (rela)
    {
        case typeStay:
            LoadPage(stay);
            break;

        case typeNeutral:
        default:
            LoadPage(neutral);
            break;

        case typeGo:
            LoadPage(go);
            break;
    }
    
}

function CalcRela()
{
    var stay = ReadVar("stay");
    var neutral = ReadVar("neutral");
    var go = ReadVar("go");

    var max = Math.max(stay, neutral, go);

    // Note that, in the case of a tie, this code explicitly chooses 
    // Stay over Go and Go over Neutral
    if (stay == max)
    {
        return typeStay;
    }
    else if (go == max)
    {
        return typeGo;
    }
    else 
    {
        return typeNeutral;
    }
}

function CheckHighRela(type)
{
    var stay = ReadVar("stay");
    var neutral = ReadVar("neutral");
    var go = ReadVar("go");

    var percentForHigh = 60;
    var sum = stay + neutral + go;
    var max = Math.max(stay, neutral, go);

    if (max < (sum * percentForHigh) / 100)
    {
        return false;
    }

    var typeVal = 0;

    switch (type)
    {
        case typeStay:
            typeVal = stay;
            break;

        case typeNeutral:
            typeVal = neutral;
            break;

        case typeGo:
            typeVal = go;
            break;
    }

    if (typeVal == max)
    {
        return true;
    }

    return false;
}

function ClearTemps()
{
    SetVar("temp0", 0);
    SetVar("temp1", 0);
    SetVar("temp2", 0);
}

// the page achieve0 is the one that shows all of them, so 
// the first real page is achive1.  Therefore, index is 
// 1 based instead of 0
function GotoAchieveIfUnlocked(index)
{
    var page = "achieve" + index;

    var achieve = gameAchieves[index - 1];

    val = ReadAchieve(achieve);
    if (val != 0)
    {
        LoadPage(page);
    }

    return false;
}

function SetAchieveImages()
{
    for (var index = 0; index < gameAchieves.length; index++)
    {
        var achieve = gameAchieves[index];
        val = ReadAchieve(achieve);
        if (val == 0)
        {
            // Achievement not unlocked, so we need to flip the image to the bw version.
            var image = document.getElementById(gImageId + index);
            if (image != null)
            {
                var str = image.src;
                str = str.replace(".jpg", "bw.jpg");
                image.src = str;
            }
        }
    }
}


//function DoPartialControl(side, frames, timeout)
//{
//    animHelper = new AnimHelper(side);
//    animHelper.SetPartialControl(frames, timeout);

//    SetMove(SimpleMove);
//    RunOnPageExit("ClearMove(SimpleMove);");
//}

function DoNormalMouseControl(side)
{
    animHelper = new AnimHelper(side);

    SetMove(SimpleMove);
    RunOnPageExit("ClearMove(SimpleMove);");
}


function E3CheckEmbarrass()
{
    var temp0 = ReadVar("temp0");

    ClearTemps();

    if (temp0 >= 3)
    {
        SetAchieve("e3embarrass");
    }
}

function E4CheckLaura()
{
    var confess = CheckEvent("events0", "e3confess");
    var laura = false;

    if (confess)
    {
        var highGo = CheckHighRela(typeGo);
        if (highGo)
        {
            laura = true;
        }
    }

    if (laura)
    {
        SetAchieve("e4laura");
        LoadPage("e4book35g");
    }
    else
    {
        LoadPage("e4book35");
    }
}

function E4CheckSandy()
{
    var peeks = ReadVar("temp0");

    ClearTemps();

    if (peeks >= 3)
    {
        SetAchieve("e4sandy");
    }
}

function E5SoG(typestr)
{
    var type = window[typestr];
    var page = "e5sog";
    var rela = CalcRela();
    var high = CheckHighRela(type);
    var letter;

    if (type == typeStay)
    {
        letter = "S";
    }
    else if (type == typeNeutral)
    {
        letter = "N";
    }
    else // typeGo
    {
        letter = "G";
    }

    if (rela != type)  //NoMatch
    {
        page += letter + "NM";
    }
    else if (high) //SuperMattch
    {
        page += letter + "SM";
    }
    else //Match
    {
        page += letter + "M";
    }

    GotoPage(page);
}

function e5CheckNSM()
{
    var sm = CheckHighRela(typeNeutral);

    if (sm)
    {
        GotoPage("e5sogNSM7");
    }
    else
    {
        GotoPage("e5sogNM7");
    }
}

function e5CheckGSM()
{
    var laura = CheckEvent("events0", "e4laura");

    if (!laura)
    {
        GotoPage("e5sogGM");
    }
}